import { Router } from 'vue-router';
import { RoutiderLocation, RoutiderLocationOfNames } from './route/location';
import { RoutiderOptions, RouteNames } from './options/options';
import { RoutiderRouter } from './router/router';
import { RoutiderNavigationGuard } from './router/navigationGuard';
interface Routider<O extends RoutiderOptions> {
    rawRouter: Router;
    router: RoutiderRouter<O>;
    useRouter: () => RoutiderRouter<O>;
    useRoute: <N extends RouteNames<O['routes']> | RouteNames<O['routes']>[] | null>(name: N) => N extends null ? RoutiderLocation<undefined, string> : RoutiderLocationOfNames<O['routes'], Exclude<N, null>>;
    onBeforeRouteLeave: (leaveGuard: RoutiderNavigationGuard<O['routes']>) => void;
    onBeforeRouteUpdate: (updateGuard: RoutiderNavigationGuard<O['routes']>) => void;
}
export declare const createRoutider: <O extends RoutiderOptions>(options: O) => Routider<O>;
export {};
